<template>
  <div class="evaluate1">
    <div class="title">
      <span>智慧应急</span>
      <img src="../../../assets/img/zonlan (9).png" alt="" />
    </div>
    <div class="top0">相关统计</div>
    <div class="top">
      <div class="top1">
        <div class="top111">
          <div class="top1110"></div>
          <div class="top1111">事件数量</div>
          <div class="top1112" v-for="(item, i) in dataArr1" :key="i">
            <div>{{ item }}</div>
          </div>
          <div class="top1113">件</div>
          <div class="top1114"></div>
        </div>

        <div class="top311">
          <div class="top1110"></div>
          <div class="top1111">待处置事件数</div>
          <div class="top1112" v-for="(item, i) in dataArr4" :key="i">
            <div>{{ item }}</div>
          </div>
          <div class="top1113">件</div>
          <div class="top1114"></div>
        </div>
      </div>

      <div class="top1">
        <div class="top221">
          <div class="top1110"></div>
          <div class="top1111">预警数量</div>
          <div class="top1112" v-for="(item, i) in dataArr3" :key="i">
            <div>{{ item }}</div>
          </div>
          <div class="top1113">条</div>
          <div class="top1114"></div>
        </div>
        <div class="top112">
          <div class="top1110"></div>
          <div class="top1111">告警数量</div>
          <div class="top1112" v-for="(item, i) in dataArr2" :key="i">
            <div>{{ item }}</div>
          </div>
          <div class="top1113">件</div>
          <div class="top1114"></div>
        </div>
        <div class="top312">
          <div class="top1110"></div>
          <div class="top1111">待处置告警数</div>
          <div class="top1112" v-for="(item, i) in dataArr5" :key="i">
            <div>{{ item }}</div>
          </div>
          <div class="top1113">件</div>
          <div class="top1114"></div>
        </div>
      </div>
    </div>
    <div class="center">
      <div id="centerChart1" class="LargeScreen"></div>
      <div id="centerChart2" class="LargeScreen"></div>
      <div id="centerChart3" class="PCScreen"></div>
      <div id="centerChart4" class="PCScreen"></div>
 
    </div>
    <div class="bottom">
      <div id="bottomChart"></div>
    </div>
  </div>
</template>

<script>
export default {
  //import引入的组件需要注入到对象中才能使用
  components: {},
  data() {
    //这里存放数据
    return {
      dataArr1: [],
      dataArr2: [],
      dataArr3: [],
      dataArr4: [],
      dataArr5: [],
      //图标数据配置
      dataX1: [],
      dataY1: [],

      dataX2: [],
      dataY2: [],

      leftoption: {},
      leftoptione: {},
      rightoption: {},
      rightoptione: {},
      bottomoption: {},
    };
  },
  //方法集合
  methods: {
    async getData() {
      const { data: dt } = await this.$http.get(
        "/jeecg-boot/statistics/statistics/queryall"
      );
      dt.result.forEach((element) => {
        if (element.name == "事件数量") {
          this.dataArr1 = this.dataLength(element.value);
        } else if (element.name == "告警数量") {
          this.dataArr2 = this.dataLength(element.value);
        } else if (element.name == "预警数量") {
          this.dataArr3 = this.dataLength(element.value);
        } else if (element.name == "待处理事件数") {
          this.dataArr4 = this.dataLength(element.value);
        } else if (element.name == "待处理告警数") {
          this.dataArr5 = this.dataLength(element.value);
        }
      });
    },
    //默认选中状态
    getDefaultSelected(myChart) {
      let index = 0;
      myChart.dispatchAction({
        type: "highlight",
        seriesIndex: 0,
        dataIndex: 0,
      });
      myChart.on("mouseover", (e) => {
        if (e.dataIndex !== index) {
          myChart.dispatchAction({
            type: "downplay",
            seriesIndex: 0,
            dataIndex: index,
          });
        }
      });
      myChart.on("mouseout", (e) => {
        index = e.dataIndex;
        myChart.dispatchAction({
          type: "highlight",
          seriesIndex: 0,
          dataIndex: e.dataIndex,
        });
      });
    },
    //字符串切割
    dataLength(parm) {
      var dataAll = [];
      for (var i = 0; i < parm.length; i++) {
        dataAll.push(parm.substring(i, i + 1));
      }
      return dataAll;
    },

    //绘制图表
    async drawLine() {
      let { data: dt } = await this.$http.get(
        "/jeecg-boot/type_statistics/typeStatistics/queryall"
      );
      let { data: dt1 } = await this.$http.get(
        "/jeecg-boot/team_distribution/teamDistribution/queryall"
      );
      let { data: dt2 } = await this.$http.get(
        "/jeecg-boot/trend/trend/queryall"
      );
      this.GetChartDataLeft1(dt.result);
      this.GetChartDataLeft2(dt1.result);
      this.GetChartLine(dt2.result);
      // 基于准备好的dom，初始化echarts实例
    },

    //饼图1
    GetChartDataLeft1(val) {
      // 	   this.dataX1 = [
      //     "数据1",
      //     "数据2",
      //     "数据3",
      //     "数据4",
      //     "数据5",
      //     "数据6",
      //     "数据7",
      //   ];
      var dataY01 = [];
      val.forEach((element) => {
        this.dataX1.push(element.name);
        dataY01.push(Number(element.value));
      });
      let leftChart = this.$echarts.init(
        document.getElementById("centerChart1")
      );
      let leftChart1 = this.$echarts.init(
        document.getElementById("centerChart3")
      );
      //数据赋值

      for (var i = 0; i < val.length; i++) {
        this.dataY1.push({
          name: this.dataX1[i],
          value: dataY01[i],
        });
      }

      var dataLegnd = this.dataY1;

      this.leftoption = {
        baseOption: {
          title: {
            text: "事件统计",
            textStyle: {
              fontSize: 25,
              color: "#FFF",
            },
            top: "5%",
            left: "center",
          },
          grid: {
            top: "10%",
            bottom: "5%",
            left: "7%",
            // right: "5%",
          },
          legend: {
            selectedMode: false,
            orient: "vertical",
            itemGap: 20,
            itemWidth: 15,
            itemHeight: 15,
            icon: "circle",
            right: "0",
            top: "center",

            data: dataLegnd,
            textStyle: {
              fontSize: 15,
              color: "#FFF",
            },
            formatter: function (name) {
              var total = 0;
              var target;
              for (var i = 0, l = dataLegnd.length; i < l; i++) {
                total += dataLegnd[i].value;
                if (dataLegnd[i].name == name) {
                  target = dataLegnd[i].value;
                }
              }
              return (
                name +
                "   " +
                ((target / total) * 100).toFixed(2) +
                "%" +
                "    " +
                target +
                "起"
              );
            },
          },
          series: [
            {
              itemStyle: {
                normal: {
                  color: function (params) {
                    var colorList = [
                      "#A8D8F0",
                      "#B1B7BA",
                      "#FF6F6E",
                      "#FBC46B",
                      "#3E6DFF",
                      "#536EBF",
                      "#6E93FF",
                      "#5FEBFF",
                      "#8AF1FF",
                      "#8AF1FF",
                    ];
                    return colorList[params.dataIndex];
                  },
                },
              },
              type: "pie",
              radius: ["30%", "50%"],
              center: ["20%", "50%"],
              label: {
                normal: {
                  show: false,
                },
              },
              data: this.dataY1,
            },
            {
              itemStyle: {
                normal: {
                  color: "#367DD7 ",
                },
              },
              type: "pie",
              hoverAnimation: false,
              radius: ["27.5%", "28%"],
              center: ["20%", "50%"],
              label: {
                normal: {
                  show: false,
                },
              },
              data: [
                {
                  value: 1,
                },
              ],
              z: -1,
            },
            {
              itemStyle: {
                normal: {
                  color: "#367DD7 ",
                },
              },
              type: "pie",
              hoverAnimation: false,
              radius: ["52.5%", "53%"],
              center: ["20%", "50%"],
              label: {
                normal: {
                  show: false,
                },
              },
              data: [
                {
                  value: 1,
                },
              ],
              z: -1,
            },
            {
              itemStyle: {
                normal: {
                  color: "#143356",
                },
              },
              type: "pie",
              hoverAnimation: false,
              radius: ["55.8%", "56%"],
              center: ["20%", "50%"],
              label: {
                normal: {
                  show: false,
                },
              },
              data: [
                {
                  value: 1,
                },
              ],
              z: -1,
            },
          ],
        },
        //媒体查询
        media: [
          {
            query: {
              minWidth: 550,
            },
            option: {
              title: {
                textStyle: {
                  fontSize: 15,
                },
              },
              legend: {
                textStyle: {
                  color: "#fff",
                  fontSize: 10,
                },
              },
              series: [
                {
                  center: ["50%", "60%"],
                },
                {
                  center: ["50%", "60%"],
                },
                {
                  center: ["50%", "60%"],
                },
                {
                  center: ["50%", "60%"],
                },
              ],
            },
          },
        ],
      };
      this.leftoptione = {
        baseOption: {
          title: {
            text: "事件统计",
            textStyle: {
              fontSize: 20,
              color: "#FFF",
            },
            top: "5%",
            left: "center",
          },
          grid: {
            top: "10%",
            bottom: "5%",
            left: "5%",
            // right: "5%",
          },
          legend: {
            selectedMode: false,
            orient: "vertical",
            itemGap: 20,
            itemWidth: 20,
            itemHeight: 20,
            icon: "circle",
            right: "0",
            top: "center",

            data: dataLegnd,
            textStyle: {
              fontSize: 20,
              color: "#FFF",
            },
            formatter: function (name) {
              var total = 0;
              var target;
              for (var i = 0, l = dataLegnd.length; i < l; i++) {
                total += dataLegnd[i].value;
                if (dataLegnd[i].name == name) {
                  target = dataLegnd[i].value;
                }
              }
              return name + "   " + target + "起";
            },
          },
          series: [
            {
              itemStyle: {
                normal: {
                  color: function (params) {
                    var colorList = [
                      "#A8D8F0",
                      "#B1B7BA",
                      "#FF6F6E",
                      "#FBC46B",
                      "#3E6DFF",
                      "#536EBF",
                      "#6E93FF",
                      "#5FEBFF",
                      "#8AF1FF",
                      "#8AF1FF",
                    ];
                    return colorList[params.dataIndex];
                  },
                },
              },
              type: "pie",
              radius: ["30%", "50%"],
              center: ["20%", "50%"],
              label: {
                normal: {
                  show: false,
                },
              },
              data: this.dataY1,
            },
            {
              itemStyle: {
                normal: {
                  color: "#367DD7 ",
                },
              },
              type: "pie",
              hoverAnimation: false,
              radius: ["27.5%", "28%"],
              center: ["20%", "50%"],
              label: {
                normal: {
                  show: false,
                },
              },
              data: [
                {
                  value: 1,
                },
              ],
              z: -1,
            },
            {
              itemStyle: {
                normal: {
                  color: "#367DD7 ",
                },
              },
              type: "pie",
              hoverAnimation: false,
              radius: ["52.5%", "53%"],
              center: ["20%", "50%"],
              label: {
                normal: {
                  show: false,
                },
              },
              data: [
                {
                  value: 1,
                },
              ],
              z: -1,
            },
            {
              itemStyle: {
                normal: {
                  color: "#143356",
                },
              },
              type: "pie",
              hoverAnimation: false,
              radius: ["55.8%", "56%"],
              center: ["20%", "50%"],
              label: {
                normal: {
                  show: false,
                },
              },
              data: [
                {
                  value: 1,
                },
              ],
              z: -1,
            },
          ],
        },
        //媒体查询
        media: [
          {
            query: {
              minWidth: 550,
            },
            option: {
              title: {
                textStyle: {
                  fontSize: 15,
                },
              },
              legend: {
                textStyle: {
                  color: "#fff",
                  fontSize: 10,
                },
              },
              series: [
                {
                  center: ["50%", "60%"],
                },
                {
                  center: ["50%", "60%"],
                },
                {
                  center: ["50%", "60%"],
                },
                {
                  center: ["50%", "60%"],
                },
              ],
            },
          },
        ],
      };
      leftChart.setOption(this.leftoption);
      leftChart1.setOption(this.leftoptione);
      this.getDefaultSelected(leftChart);
    },

    //饼图2
    GetChartDataLeft2(val) {
      var dataY02 = [];
      val.forEach((element) => {
        this.dataX2.push(element.name);
        dataY02.push(Number(element.value));
      });
      let rightChart = this.$echarts.init(
        document.getElementById("centerChart2")
      );
      let rightChartone = this.$echarts.init(
        document.getElementById("centerChart4")
      );
     
      var colorList = [
        "#A8D8F0",
        "#B1B7BA",
        "#FF6F6E",
        "#FBC46B",
        "#3E6DFF",
        "#536EBF",
        "#6E93FF",
        "#5FEBFF",
        "#8AF1FF",
        "#8AF1FF",
      ];
      var total = this.sum(dataY02);
      for (var i = 0; i < dataY02.length; i++) {
        this.dataY2Total += parseFloat(dataY02[i]);
        this.dataY2.push({
          name: this.dataX2[i],
          color: colorList[i],
          total: total,
          value: dataY02[i],
        });
      }

      this.rightoption = {
        baseOption: {
          color: colorList,
          title: {
            text: "事件统计",
            textStyle: {
              fontSize: 25,
              color: "#FFF",
            },
            top: "5%",
            left: "center",
          },
          legend: {
            type: "scroll",
            
            orient: "vertical",
            left: "left",
            top: "center",
            icon: "circle",
            itemGap: 20,
            itemWidth: 20,
            itemHeight: 20,
            textStyle: {
              fontSize: 20, //字体大小
              color: "#ffffff", //字体颜色
            },
          },
          series: [
            {
              type: "pie",
              radius: ["30%", "50%"],
              center: ["50%", "50%"],
              label: {
                normal: {
                  show: false,
                },
              },
              data: this.dataY2,
            },
            {
              itemStyle: {
                normal: {
                  opacity: 0.5,
                },
              },
              type: "pie",
              hoverAnimation: false,
              radius: ["30%", "60%"],
              center: ["50%", "50%"],
              label: {
                normal: {
                  show: false,
                },
              },
              data: this.dataY2,
              z: -1,
            },
          ],
        },
        //媒体查询
        media: [
          {
            query: {
              minWidth: 550,
            },
            option: {
              title: {
                textStyle: {
                  fontSize: 15,
                },
              },
              legend: {
                textStyle: {
                  color: "#fff",
                  fontSize: 10,
                },
              },
              series: [
                {
                  center: ["50%", "60%"],
                  //   radius: "50%",
                },
                {
                  center: ["50%", "60%"],
                  //   radius: "50%",
                },
              ],
            },
          },
        ],
      };

      this.rightoptione = {
        baseOption: {
          color: colorList,
          title: {
            text: "事件统计",
            textStyle: {
              fontSize: 20,
              color: "#FFF",
            },
            top: "5%",
            left: "center",
          },
          legend: {
            type: "scroll",
            // orient: "vertical",
            orient: "vertical",
            left: "right",
            top: "center",
            icon: "circle",
            itemGap: 20,
            itemWidth: 20,
            itemHeight: 20,
            textStyle: {
              fontSize: 20, //字体大小
              color: "#ffffff", //字体颜色
            },
          },
          
          series: [
            {
              type: "pie",
              radius: ["30%", "50%"],
              center: ["50%", "50%"],
              label: {
                normal: {
                  show: false,
                },
              },
              data: this.dataY2,
            },
            {
              itemStyle: {
                normal: {
                  opacity: 0.5,
                },
              },
              type: "pie",
              hoverAnimation: false,
              radius: ["30%", "60%"],
              center: ["50%", "50%"],
              label: {
                normal: {
                  show: false,
                },
              },
              data: this.dataY2,
              z: -1,
            },
          ],
        },
        //媒体查询
        media: [
          {
            query: {
              minWidth: 550,
            },
            option: {
              title: {
                textStyle: {
                  fontSize: 15,
                },
              },
              legend: {
                textStyle: {
                  color: "#fff",
                  fontSize: 10,
                },
              },
              series: [
                {
                  center: ["50%", "60%"],
                  //   radius: "50%",
                },
                {
                  center: ["50%", "60%"],
                  //   radius: "50%",
                },
              ],
            },
          },
        ],
      };

      rightChart.setOption(this.rightoption);

      rightChartone.setOption(this.rightoptione)
      this.getDefaultSelected(rightChart);
    },

    //线型图
    GetChartLine(val) {
      var dataX3 = [];
      var dataY31 = [];
      var dataY32 = [];
      var dataY33 = [];
      val.forEach((e) => {
        dataX3.push(e.time);
        if (e.name == "事件") {
          dataY31.push(e.value);
        }
        if (e.name == "告警") {
          dataY32.push(e.value);
        }
        if (e.name == "预警") {
          dataY33.push(e.value);
        }
      });
      let bottomChart = this.$echarts.init(
        document.getElementById("bottomChart")
      );

      this.bottomoption = {
        baseOption: {
          color: ["#FDFE02", "#2AB5E0", "#EB0253"],

          title: {
            text: "各级财政投入扶贫专项资金",
            left: "center",
            textStyle: {
              color: "#fff",
              fontSize: 25,
            },
          },
          grid: {
            left: "20",
            right: "0",
            bottom: "70",
            top: "80",
            containLabel: true,
          },
          tooltip: {
            trigger: "axis",
            axisPointer: {
              type: "none",
              label: {
                show: true,
                backgroundColor: "#333",
              },
            },
          },
          legend: {
            show: true,
            x: "right",
            top: "40",
            textStyle: {
              color: "#fff",
            },
            data: ["事件", "告警", "预警"],
          },
          xAxis: [
            {
              type: "category",
              axisLabel: {
                textStyle: {
                  color: "rgba(207, 227, 252, 1)",
                  fontSize: 18,
                },
              },
              axisLine: {
                show: true,
                lineStyle: {
                  color: "#5D6675",
                },
              },
              data: dataX3,
            },
          ],
          yAxis: [
            {
              type: "value",
              name: "",
              axisLine: {
                lineStyle: {
                  color: "#FFF",
                },
              },
              splitLine: {
                //分割线
                show: true,
                lineStyle: {
                  type: "solid",
                  color: "#303D4B",
                },
              },
            },
          ],
          series: [
            {
              name: "事件",
              type: "line",
              symbol: "circle",
              symbolSize: 8,

              itemStyle: {
                normal: {
                  areaStyle: {
                    //color: '#94C9EC'
                    color: new this.$echarts.graphic.LinearGradient(
                      0,
                      1,
                      0,
                      0,
                      [
                        {
                          offset: 0,
                          color: "rgba(7,44,90,0)",
                        },
                        {
                          offset: 1,
                          color: "rgba(253,254,2,0.5)",
                        },
                      ]
                    ),
                  },
                },
              },

              data: dataY31,
            },
            {
              name: "告警",
              type: "line",
              symbol: "circle",
              symbolSize: 8,

              itemStyle: {
                normal: {
                  areaStyle: {
                    //color: '#94C9EC'
                    color: new this.$echarts.graphic.LinearGradient(
                      0,
                      1,
                      0,
                      0,
                      [
                        {
                          offset: 0,
                          color: "rgba(7,44,90,0)",
                        },
                        {
                          offset: 1,
                          color: "rgba(42,181,224,0.5)",
                        },
                      ]
                    ),
                  },
                },
              },
              data: dataY32,
            },
            {
              name: "预警",
              type: "line",
              symbol: "circle",
              symbolSize: 8,
              itemStyle: {
                normal: {
                  areaStyle: {
                    color: new this.$echarts.graphic.LinearGradient(
                      0,
                      1,
                      0,
                      0,
                      [
                        {
                          offset: 0,
                          color: "rgba(7,44,90,0)",
                        },
                        {
                          offset: 1,
                          color: "rgba(235,2,83,0.5)",
                        },
                      ]
                    ),
                  },
                },
              },
              data: dataY33,
            },
          ],
        },
        //媒体查询
        // media: [
        //   {
        //     query: {
        //       minWidth: 550,
        //     },
        //     option: {
        //       title: {
        //         textStyle: {
        //           fontSize: 15,
        //         },
        //       },
        //       legend: {
        //         textStyle: {
        //           color: "#fff",
        //           fontSize: 10,
        //         },
        //       },
        //     },
        //   },
        // ],
      };
      bottomChart.setOption(this.bottomoption);
    },

    //数组求和
    sum(arr) {
      return eval(arr.join("+"));
    },
  },
  mounted() {
    this.getData();

    this.drawLine();
  },
  created() {},
};
</script>
<style lang="less" scoped>
#centerChart5{
  display:none
}
.evaluate1 {
  height: 100%;
  width: 100%;
  background: rgba(8, 32, 58, 0.7);
  .title {
    width: 100%;
    position: relative;

    img {
      width: 100%;
    }

    span {
      font-size: 78px;
      font-weight: 400;
      color: #ffe86b;
      background: linear-gradient(0deg, #bce7ff 0%, #69efff 98.6572265625%);
      -webkit-background-clip: text;
      -webkit-text-fill-color: transparent;
      position: absolute;
      left: 50%;
      top: 0;
      transform: translateX(-50%);
    }
  }
  .top0 {
    // height: 15%;
    padding: 30px 0;
    display: flex;
    align-items: center;
    justify-content: center;
    font-size: 59px;
    color: #ffffff;
  }
  .top {
    box-sizing: border-box;
    padding: 0 40px;
    height: 30%;
    width: 100%;
    display: flex;
    justify-content: space-between;
    flex-wrap: wrap;

    .top1 {
      // height: 95%;
      width: 50%;
      display: flex;
      flex-flow: wrap;
      justify-content: space-around;
      align-content: space-between;
      .top111 {
        background-image: url(../../../assets/img/事件数量.png);
      }

      .top112 {
        background-image: url(../../../assets/img/告警数量.png);
      }

      .top311 {
        background-image: url(../../../assets/img/待处置事件数.png);
      }

      .top312 {
        background-image: url(../../../assets/img/待处置告警数.png);
      }
      .top221 {
        background-image: url(../../../assets/img/预警数量.png);
      }
      .top111,
      .top112,
      .top311,
      .top312,
      .top221 {
        height: 256px;
        width: 956px;
        // height: 90%;
        // width: 49%;
        background-size: 100% 100%;
        background-repeat: no-repeat;
        display: flex;
        flex-direction: row;
        align-items: center;
        justify-content: space-around;
        color: #ffffff;
      }
    }
  }

  .top1110 {
    width: 12%;
  }

  .top1111 {
    width: 40%;
    font-size: 57px;
    padding-left: 20px;
  }

  .top1112 {
    background-color: #053f55;
    width: 80px;
    height: 60%;
    display: flex;
    align-items: center;
    justify-content: center;
    color: #ffff00;
  }

  .top1114 {
    width: 5%;
  }
  .PCScreen {
    display: none;
  }
  .center {
    height: 30%;
    width: 100%;
    display: flex;
    align-items: center;
    flex-direction: row;

    #centerChart1 {
      height: 100%;
      width: 50%;
    }

    #centerChart2 {
      height: 100%;
      width: 50%;
    }
  }

  .bottom {
    height: 30%;
    width: 100%;

    #bottomChart {
      height: 100%;
      width: 100%;
    }
  }
}
@media only screen and (max-width: 2560px) {
  .evaluate1 {
    overflow: visible;
    height: auto;
    background: transparent;
   .top0{
 font-size: 0.1rem;
    font-weight: bolder;  
   }    
   .top {
      height: 50%;
      width: 100%;
        margin-top:5%;  
      .top1 {
        width: 50%;

        .top111,
        .top112,
        .top311,
        .top221,
        .top312 {
          width: 80%;
        }
      }
      //   .top2 {
      //     width: 50%;
      //     .top221 {
      //       width: 80%;
      //     }
      //   }
    }
    .PCScreen {
      display: block;
    }
    .LargeScreen {
      display: none;
    }
    .center {
      height: auto;
      flex-direction: column;

      #centerChart3 {
        height: 2000px;
        width: 100%;
        margin-left: 1%;
         margin-top:5%;
      }

      #centerChart4 {
       display:none;
        height: 2000px;
        width: 100%;
        margin-left: -45%;
        margin-top: -13%;
      }

    }
    .bottom {
      height: auto;
      margin-top:5%;
      #bottomChart {
        height: 2100px;
        margin-top: -7%;
      }
    }
  }
}
</style>
